/****************************************************************************
 **
 **  Copyright (C) 2007 by Helge Kortendieck, qvtwfc@kasmithee.de
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 or later as published by the Free Software Foundation
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ****************************************************************************/

#ifndef _FCS_H_
#define _FCS_H_

#include <QDir>
#include <QFile>
#include <QFileInfo>
#include <QObject>
#include <QString>

class fcs : public QObject
{
  Q_OBJECT

public:
//  fcs( QObject *parent = 0, const char *name = 0 );
  fcs( QObject *parent = 0 );
     ~fcs();

  bool bKde;                // KDE installed (.kde dir found)
  bool bKdeSet;             // set/unset qvtwfc.desktop in ~/.kde/Autostart
  bool bGnome;              // GNOME installed (.gnome2 dir found)
  bool bGnomeSet;           // set/unset qvtwfc.desktop in ~/.config/autostart

  int iErr;                 // error code

  QString sErrTit;          // error message titel
  QString sErrTxt;          // error message text

public slots:
    /*$PUBLIC_SLOTS$*/
  virtual void state();     // check if qvtwfc.desktop is present in autostart dirs of available desktops
  virtual void set();       // place qvtwfc.desktop into autostart dir to start it with desktop session
  virtual void unset();     // delete qvtwfc.desktop from autostart dir so it will not start with desktop session

  signals:
   // set/unset state
  void sigState( bool bKde, bool bKdeSet, bool bGnome, bool bGnomeSet, const QString& sErrTit, const QString& sErrTxt, int iErr );

protected:
    /*$PROTECTED_FUNCTIONS$*/

private:
  bool bD;

  int iD;
  int iD2;

  QString sCpDel;           // part of error text either 'copy' or 'delete'
  QString sCpKde;           // part of error text, could not copy or del desktop file in KDE autostart dir
  QString sCpGnome;         // part of error text, could not copy or del desktop file in GNOME autostart dir
  QString sCpStr;           // part of error text, last sentence
  QString sD;
  QString sDErr;            // dummy error string
  QString sFOrig;           // full path and name to original qvtwfc.desktop file in system
  QString sFKde;            // full path and name to qvtwfc.desktop file in KDE autostart directory
  QString sFGnome;          // full path and name to qvtwfc.desktop file in GNOME autostart directory
  QString sHome;            // full path to users home directory (incl. closing '/')

private slots:
  void check();             // check for available desktops
  void errClear();          // clear error code and text
  void err();               // set error text according error code

  signals:

};

#endif // _FCS_H_
